unit hiReBar;

interface

uses kol,Share,Debug,windows;

procedure ClearText(Sender: PControl);

const
  WM_SIZE             = $0005;
  WM_MOVE             = $0003;

  ID_REBAR            = 2000;
  WM_USER             = $0400;
  REBARCLASSNAME      = 'ReBarWindow32';
  RBS_VARHEIGHT       = $00000200;
  RBS_BANDBORDERS     = $00000400;
  RBS_DBLCLKTOGGLE    = $00008000;
  RBBIM_SIZE          = $00000040;
  RBBIM_CHILD         = $00000010;
  RBBIM_ID            = $00000100;
  RBBIM_STYLE         = $00000001;
  RBBIM_TEXT          = $00000004;
  RBBIM_CHILDSIZE     = $00000020;
  RBBS_CHILDEDGE      = $00000004;
  RBBS_GRIPPERALWAYS  = $00000080;
  RB_INSERTBAND       = WM_USER + 1;
  RBBS_BREAK          = $00000001;  // break to new line
  RB_SETPARENT        = WM_USER + 7;
  RBBIM_COLORS        = $00000002;
  RBBS_FIXEDBMP       = $00000020;
  RB_DELETEBAND       = WM_USER + 2;
  RB_GETBANDCOUNT     = WM_USER + 12;
  RB_SHOWBAND         = WM_USER + 35; // show/hide band
  RB_MOVEBAND         = WM_USER + 39;
  RB_SETBANDINFO      = WM_USER +  6;
  RBBS_FIXEDSIZE      = $00000002;    // band can't be sized
  RBS_AUTOSIZE        = $00002000;
  RB_IDTOINDEX        = WM_USER + 16; // wParam == id
  RB_GETBANDINFO      = WM_USER + 29;
  RB_SIZETORECT       = WM_USER + 23; // resize the rebar/break bands and such to this rect (lparam;
  RBS_VERTICALGRIPPER = $00004000;    // this always has the vertical gripper (default for horizontal mode)
  RBBIM_HEADERSIZE    = $00000800;    // control the size of the header
  RBBIM_IDEALSIZE     = $00000200;
  RBBS_NOGRIPPER      = $00000100;    // never show the gripper
  RBBS_VARIABLEHEIGHT = $00000040;    // allow autosizing of this child vertically

  LabelActions: TCommandActions = (
    aClear: ClearText;
    aAddText: nil;
    aClick: 0;
    aEnter: 0;
    aLeave: 0;
    aChange: 0;
    aSelChange: 0;
    aGetCount: 0;
    aSetCount: 0;
    aGetItemLength: 0;
    aGetItemText: 0;
    aSetItemText: 0;
    aGetItemData: 0;
    aSetItemData: 0;
    aAddItem: 0;
    aDeleteItem: 0;
    aInsertItem: 0;
    aFindItem: 0;
    aFindPartial: 0;
    aItem2Pos: 0;
    aPos2Item: 0;
    aGetSelCount: 0;
    aGetSelected: 0;
    aGetSelRange: 0;
    aExGetSelRange: 0;
    aGetCurrent: 0;
    aSetSelected: 0;
    aSetCurrent: 0;
    aSetSelRange: 0;
    aExSetSelRange: 0;
    aGetSelection: 0;
    aReplaceSel: 0;
    aTextAlignLeft: SS_LEFT;
    aTextAlignRight: SS_RIGHT;
    aTextAlignCenter: SS_CENTER;
    aTextAlignMask: SS_LEFTNOWORDWRAP;
    aVertAlignCenter: SS_CENTERIMAGE shr 8;
    aVertAlignTop: 0;
    aVertAlignBottom: 0;
    aDir: 0;
    aSetLimit: 0;
    aSetImgList: 0;
    aAutoSzX: 1;
    aAutoSzY: 1;
    aSetBkColor: 0;
  );

type
  TReBarBandInfo = packed record
    cbSize: UINT;
    fMask: UINT;
    fStyle: UINT;
    clrFore: TColorRef;
    clrBack: TColorRef;
    lpText: PAnsiChar;
    cch: UINT;
    iImage: Integer;
    hwndChild: HWnd;
    cxMinChild: UINT;
    cyMinChild: UINT;
    cx: UINT; //  
    hbmBack: HBitmap;
    wID: UINT;
    cyChild: UINT;
    cyMaxChild: UINT;
    cyIntegral: UINT;
    cxIdeal: UINT;
    lParam: LPARAM;
    cxHeader: UINT;
  end;

type
  TInitCommonControlsEx = packed record
    dwSize: DWORD;
    dwICC: DWORD;
  end;
  PInitCommonControlsEx = ^TInitCommonControlsEx;

//type
//  TCoolBarPosition = (cbp_Left, cbp_Top, cbp_Right, cbp_Bottom);

type
 {$ifdef F_P}
  TCoolbar = class;
  PCoolbar = ^TCoolbar;
  TCoolbar = class(Tcontrol)
 {$else}
  PCoolbar = ^TCoolbar;
  TCoolbar = object(Tcontrol)
 {$endif}
  private
    function GetBandCount:integer;

  public
    procedure SetCaption (var ABandInfo: TReBarBandInfo; BandText: PChar; idx: integer );
    procedure AddBand(const Ctrl:PControl; bandWidht:Integer;
                        BandText: string; idx: integer; St: integer);
    //procedure DeleteBand(const index:integer);overload;
    procedure ShowBand(const index:integer;Show_:Integer);overload;
    procedure MoveBand(FromIndex,ToIndex:Integer);
    procedure GetInfo(var ABandInfo: TReBarBandInfo; idx: integer);
    procedure BandFixeSize(var ABandInfo: TReBarBandInfo; idx: integer);
    property  Count:integer read GetBandCount;

  end;

type
  THIReBar = class(TDebug)
   private
    FCount:word;
    FData: TData;
    FlistCaption:PStrList;
    FCaption:string;
    ToCaption:string;
    ArrCount: array [0..50] of Integer;
    Ini: PIniFile;
    CBR:PCoolbar;
    procedure SetCount(Value:integer);
    procedure SetText(const Value:string);

   public
    _prop_Align:byte;
    _prop_Visible:byte;
    _prop_FileName:string;

    Handle:array of THI_Event;
    _event_onErr:THI_Event;
    _event_onCreate:THI_Event;
    _event_onResize:THI_Event;
    constructor Create;
    destructor Destroy; override;
    function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; //virtual;
    function ReadControlEx(PointData:THI_Event):PControl;
    procedure _work_doCreateReBar(var _Data:TData; Index:word);
    procedure _work_doSaveBand(var _Data:TData; Index:word);
    procedure _work_doShowHideBand(var _Data:TData; Index:word);
    procedure _work_doAddCaption(var _Data:TData; Index:word);
    procedure _work_doAddBand(var _Data:TData; Index:word);
    procedure _work_doShowBand(var _Data:TData; Index:word);
    procedure _work_doHideBand(var _Data:TData; Index:word);
    procedure _work_doSetCaption(var _Data:TData; Index:word);
    procedure _work_doBandFixeSize(var _Data:TData; Index:word);
    procedure _work_doVisible(var _Data:TData; Index:word);
    procedure _work_doAlign(var _Data:TData; Index:word);
    property  _prop_Count:integer write SetCount;
    procedure _var_BandCount(var _Data:TData; Index:word);
    procedure _var_Left(var _Data:TData; Index:word);
    procedure _var_Top(var _Data:TData; Index:word);
    procedure _var_Width(var _Data:TData; Index:word);
    procedure _var_Height(var _Data:TData; Index:word);
    property _prop_ListBandText:string write SetText;
  end;

function NewCoolbar(AParent: PControl): PCoolbar;

implementation

const
  cctrl = 'comctl32.dll';

var
  ComCtl32DLL: THandle;
  _InitCommonControlsEx: function(var ICC: TInitCommonControlsEx): Bool; stdcall;

procedure InitCommonControls; external cctrl name 'InitCommonControls';

procedure InitComCtl;
begin
  if ComCtl32DLL = 0 then
  begin
    ComCtl32DLL := GetModuleHandle(cctrl);
    if ComCtl32DLL <> 0 then
      @_InitCommonControlsEx := GetProcAddress(ComCtl32DLL, 'InitCommonControlsEx');
  end;
end;

function InitCommonControlsEx(var ICC: TInitCommonControlsEx): Bool;
begin
  if ComCtl32DLL = 0 then InitComCtl;
  Result := Assigned(_InitCommonControlsEx) and _InitCommonControlsEx(ICC);
end;

procedure ClearText(Sender: PControl);overload;
begin
  Sender.Caption := '';
end;

type
{$ifdef F_P}
  THack = class;
  PHack = THack;
  Thack = class(Tcontrol)
{$else}
  PHack = ^THack;
  Thack = object(Tcontrol)
{$endif}
 end;

function NewCoolbar( AParent: PControl): PCoolbar;
var
  STyle:integer;
  ICCRec: TINitCommonControlsEx;
begin
  ICCRec.dwSize := sizeof(ICCRec);
  ICCRec.dwICC := ICC_Cool_Classes;
  InitCommonControlsEx(ICCRec);
  style := ws_Visible or ws_Child or ws_Border or ws_ClipChildren or ws_ClipSiblings;
  style := style or RBS_VarHeight or rbs_BandBorders or RBBS_BREAK;
  style := style or CCS_NoDivider or CCS_NoParentAlign;
  Result := PCoolbar(_NewControl( AParent, RebarClassName, Style,false,@LabelActions));
  Result.ClsStyle := ws_ex_Toolwindow;
  Result.ExStyle := PHack(Result).fExStyle or WS_EX_CONTROLPARENT;
  PHack(Result).fSizeRedraw:=true;
  sendmessage(Result.GetWindowHandle,RB_SETPARENT,Aparent.GetWindowHandle,0);
end;

procedure TCoolbar.AddBand;
var rc:TRect;
    bi:TReBarBandInfo;
begin
    FillChar (bi, sizeof (TReBarBandInfo), 0);
    //ZeroMemory(@bi,sizeof(TReBarBandInfo));
    GetWindowRect (Ctrl.GetWindowHandle, rc);
    with bi do
    begin
        fMask := RBBIM_SIZE or RBBIM_CHILD or RBBIM_CHILDSIZE or
                 RBBIM_ID or RBBIM_STYLE or RBBIM_TEXT or RBBIM_COLORS;
        //if bandWidht = 0 then
        cxMinChild := rc.Right - rc.Left;
        cyMinChild := rc.bottom - rc.top;
        lpText := PChar(BandText);
        clrFore := GetSysColor(Color_BtnText);
        clrBack := GetSysColor(Color_BtnFace);
        //clrFore := Parent.Font.Color;
        //clrBack := Parent.Color;
        fStyle := st or RBBS_CHILDEDGE or RBBS_GRIPPERALWAYS;
        hwndChild := Ctrl.GetWindowHandle; // handle
        cx := bandWidht; //  
        iImage := 0;
        wID:=idx;//Ctrl.Getwindowhandle; // 
        cbSize := sizeof(bi);
    end;
    Ctrl.parent:=@Self;
    windows.SetParent(Ctrl.Handle,Handle);
    perform(RB_InsertBand, -1, LongInt (@bi));
end;

procedure TCoolbar.SetCaption(var ABandInfo: TReBarBandInfo; BandText: PChar; idx: integer );
begin
  ZeroMemory(@ABandInfo,sizeof(ABandInfo));
  ABandInfo.cbSize := sizeof(TRebarBandInfo);
  ABandInfo.fMask := RBBIM_ID or RBBIM_SIZE or RBBIM_STYLE or RBBIM_TEXT;
  perform(RB_GETBANDINFO, idx, LPARAM(@ABandInfo));
  ABandInfo.lpText := BandText;
  perform(RB_SETBANDINFO, idx, LongInt(@ABandInfo));
  //SendMessage(CBR.Handle,RB_SETBANDINFO,idx,LPARAM(@ABandInfo));
end;

procedure TCoolbar.GetInfo(var ABandInfo: TReBarBandInfo; idx: integer);
begin
  ABandInfo.cbSize := Sizeof(TReBarBandInfo);
  ABandInfo.fMask := RBBIM_ID or RBBIM_SIZE or RBBIM_STYLE or RBBIM_TEXT;
  perform(RB_GETBANDINFO, idx, LongInt(@ABandInfo));
end;

procedure Tcoolbar.BandFixeSize(var ABandInfo: TReBarBandInfo; idx: integer);
begin
  ZeroMemory(@ABandInfo,sizeof(ABandInfo));
  ABandInfo.cbSize := sizeof(TRebarBandInfo);
  perform(RB_GETBANDINFO, idx, LPARAM(@ABandInfo));
  ABandInfo.fMask := RBBIM_ID or RBBIM_STYLE or RBBIM_TEXT;
  ABandInfo.fStyle := RBBS_CHILDEDGE
                   or RBBS_GRIPPERALWAYS
                   or RBBS_FIXEDSIZE;
  perform(RB_SETBANDINFO, idx, LPARAM(@ABandInfo));
end;
{
procedure TCoolbar.DeleteBand(const index: integer);
begin
   perform(RB_DELETEBAND,Index,0);
end;
}
function Tcoolbar.GetBandCount:integer;
begin
  Result:=perform(RB_GETBANDCOUNT,0,0);
end;

procedure TCoolbar.ShowBand(const index: integer;Show_:Integer);
begin
  sendmessage(GetwindowHandle,RB_SHOWBAND,index,Show_);
end;

procedure Tcoolbar.MoveBand(FromIndex,ToIndex:Integer);
begin
  perform(RB_MOVEBAND,Min(Count-1,FromIndex),Min(Count-1,ToIndex));
end;

constructor THIReBar.Create;
begin
   inherited Create;
   FlistCaption := NewStrList;
   New(CBR);
end;

destructor THIReBar.Destroy;
begin
   FlistCaption.Free;
   FreeData(@FData);
   CBR.Free;
   inherited Destroy;
end;

function THIReBar.ReadControlEx;
var dt:TData;
begin
  dt.Data_type := data_null;
  _ReadData(dt,PointData);
  if( Dt.Data_type = data_int)then
   Result := PControl(dt.idata)
  else Result := nil;
end;

procedure THIReBar._work_doVisible;
begin
  case _Data.idata of
    1: begin CBR.Visible := True;  ArrCount[_Data.idata] := 1; end;
    0: begin CBR.Visible := False; ArrCount[_Data.idata] := 0; end;
  end;
end;

procedure THIReBar._work_doAlign;
begin
  case _Data.idata of
    1: CBR.Setalign(caBottom);
    0: CBR.Setalign(caTop);
  end;
end;

procedure THIReBar._work_doCreateReBar;
var i,id,w,st: Integer; txtband: string;
begin
  New(CBR);
  CBR:=NewCoolbar(ReadControlEx(Handle[0]));
  ArrCount[0] := 1;
  case _prop_Visible of
    0: CBR.Visible := True;
    1: CBR.Visible := False;
  end;
  case _prop_Align of
    1: CBR.Setalign(caBottom);
    0: CBR.Setalign(caTop);
  end;
  if FileExists(_prop_FileName) then begin
     Ini := OpenIniFile(ReadFileName(_prop_FileName));
     Ini.Mode := ifmRead;
     Ini.Section := 'BandInfo';
     for i := 0 to FCount-2 do begin
       id := Ini.ValueInteger('BandID_' + Int2Str(i), 0);
       w  := Ini.ValueInteger('BandID_' + Int2Str(i) + '_Widht', 0);
       st := Ini.ValueInteger('BandID_' + Int2Str(i) + '_Style', 0);
       txtband := FlistCaption.Items[id];
       CBR.AddBand(ReadControlEx(Handle[id+1]), w, txtband, i, st);
     end;
  end
  else begin
    for i := 0 to FCount-2 do begin
      txtband := FlistCaption.Items[i];
      CBR.AddBand(ReadControlEx(Handle[i+1]), 0,
                  txtband, i,RBBS_CHILDEDGE or
                  RBBS_GRIPPERALWAYS);
      ArrCount[i] := 1;
    end;
  end;
  CBR.OnMessage := _OnMessage;
  _hi_OnEvent(_event_onCreate, '');
  Ini.Free;
end;

//      ReBar(a)
function THIReBar._OnMessage;
begin
   Result := False;
   case Msg.message of
     WM_SIZE: _hi_OnEvent(_event_onResize, CBR.Height);
   end;
end;

procedure THIReBar._work_doShowHideBand;
var  idx:integer;
     dt: Boolean;
begin
   idx := ToIntIndex(_Data);
   dt := not Boolean(ArrCount[idx]);
   ArrCount[idx] := Integer(dt);
   CBR.ShowBand(idx, ArrCount[idx]);
end;

procedure THIReBar._work_doBandFixeSize;
var idx,i: Integer;
    bi:TReBarBandInfo;
begin
   idx := ToIntIndex(_Data);
   i := SendMessage(CBR.Handle,RB_IDTOINDEX,idx,0);
   CBR.BandFixeSize(bi, i);
end;
{
procedure THIReBar._work_doDeleteBand;
var  ind:integer;
begin
  ind := ToIntIndex(_Data);
  CBR.perform(RB_DELETEBAND,ind,0);
  dec(FCount);
end;
}
procedure THIReBar._work_doAddCaption;
begin
  FCaption := ToString(_Data);
end;

procedure THIReBar._work_doAddBand;
var d:PData; dt:TData;
    pband,bandwidht:Integer;
    ccap: string;
begin
   FreeData(@FData); dtNull(dt);
   FData := ReadMTData(_data,Null);
   CopyData(@FData,@FData);
   d := @FData;
   dt := ReadData(d^,Null); pband := ToInteger(dt);
   dt := ReadData(d^,Null); bandwidht := ToInteger(dt);
   dt := ReadData(d^,Null); ccap := ToString(dt);
   CBR.AddBand (PControl(pband), bandwidht, PChar(ccap),
                CBR.Count+1,RBBS_CHILDEDGE or RBBS_GRIPPERALWAYS);
end;

procedure THIReBar._work_doShowBand;
var  idx,i:integer;
begin
  idx := ToIntIndex(_Data);
  i := SendMessage(CBR.Handle,RB_IDTOINDEX,idx,0);
  CBR.ShowBand(i, 1);
  ArrCount[idx] := 1;
end;

procedure THIReBar._work_doHideBand;
var  idx,i:integer;
begin
  idx := ToIntIndex(_Data);
  i := SendMessage(CBR.Handle,RB_IDTOINDEX,idx,0);
  CBR.ShowBand(i, 0);
  ArrCount[idx] := 0;
end;

procedure THIReBar._work_doSetCaption;
var d:PData; dt:TData;
    idx,i:Integer;
    bi:TReBarBandInfo;
begin
   FreeData(@FData); dtNull(dt);
   FData := ReadMTData(_data,Null);
   CopyData(@FData,@FData);
   d := @FData;
   dt := ReadData(d^,Null); idx := ToInteger(dt);
   dt := ReadData(d^,Null); ToCaption := dt.sdata;
   i := SendMessage(CBR.Handle,RB_IDTOINDEX,idx,0);
   CBR.SetCaption(bi,PChar(ToCaption),i);
   //_hi_OnEvent(_event_onErr, ToCaption);
end;

procedure THIReBar.SetText;
begin
   FlistCaption.SetText(Value, false);
end;

procedure THIReBar.SetCount;
begin
   FCount := Value;
   SetLength(Handle,Value);
end;

procedure THIReBar._work_doSaveBand;
var i,idx:integer;
    w,st:integer;
    bi:TReBarBandInfo;
begin
  New(ini);
  Ini := OpenIniFile(ReadFileName(_prop_FileName));
  Ini.Mode := ifmWrite;
  Ini.Section := 'BandInfo';
  for i := 0 to CBR.Count-1 {FCount-2} do begin
    idx := SendMessage(CBR.Handle,RB_IDTOINDEX,i,0);
    Ini.ValueInteger ('BandID_' + Int2Str(idx),i);
    ZeroMemory(@bi,sizeof(bi));
    bi.cbSize := sizeof(TRebarBandInfo);
    CBR.GetInfo(bi,idx);
    w := bi.cx;
    st := bi.fStyle;
    Ini.ValueInteger ('BandID_' + Int2Str(idx) + '_Widht', w);
    Ini.ValueInteger ('BandID_' + Int2Str(idx) + '_Style', st);
  end;
  Ini.Free;
  _hi_OnEvent(_event_onErr, PChar(bi.lpText));
end;

procedure THIReBar._var_BandCount;
begin
   dtInteger(_Data,CBR.Count);
end;

procedure THIReBar._var_Left(var _Data:TData; Index:word);
begin
   dtInteger(_Data,CBR.Left);
end;
procedure THIReBar._var_Top(var _Data:TData; Index:word);
begin
   dtInteger(_Data,CBR.Top);
end;
procedure THIReBar._var_Width(var _Data:TData; Index:word);
begin
  dtInteger(_Data,CBR.Width);
end;
procedure THIReBar._var_Height(var _Data:TData; Index:word);
begin
  dtInteger(_Data,CBR.Height);
end;

initialization

finalization

end.
